(*        GREATIS DELPHI PAGES         *)
(* Copyright (C) 2001 Greatis Software *)
(*  web: http://www.greatisdelphi.com  *)
(*     e-mail: delphi@greatis.com      *)

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShlObj, ShellAPI;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Folder: Integer;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  MyItemIDList: PItemIDList;
  MyShellEx: TShellExecuteInfo;
begin
  SHGetSpecialFolderLocation(Form1.Handle, Folder, MyItemIDList);
  with MyShellEx do
  begin
    cbSize:=Sizeof(MyShellEx);
    fMask:=SEE_MASK_IDLIST;
    Wnd:=Handle;
    lpVerb:=nil;
    lpFile:=nil;
    lpParameters:=nil;
    lpDirectory:=nil;
    nShow:=SW_SHOWNORMAL;
    hInstApp:=0;
    lpIDList:=MyItemIDList;
  end;
  ShellExecuteEx(@MyShellEx);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0: Folder:=CSIDL_DRIVES;
    1: Folder:=CSIDL_CONTROLS;
    2: Folder:=CSIDL_DESKTOP;
    3: Folder:=CSIDL_BITBUCKET;
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  Folder:=CSIDL_DRIVES;
end;

end.
